import { parse } from "@babel/parser";
import traverse from "@babel/traverse";
import generate from "@babel/generator";
import * as t from "@babel/types";
import fs from "fs";
import UglifyJS from "uglify-js";



const srcArray = JSON.parse("[\"692066yhNvTK\",\"speed\",\"SHA-256\",\"isFirefox\",\"styles\",\"fontStyle\",\"subscribe\",\"defineProperties\",\"possiblilty\",\"left\",\"pxlscn-speech-synthesis\",\"hwb\",\"timeFromIP\",\"justify-content-between\",\"getAttribute\",\"firefox-11-22\",\"Oqu\",\" No automation framework detected \",\"timezoneJS\",\"test failed: \",\"col-10\",\"pr-7\",\"Opera-12-16\",\"The `level` option should be an integer from 0 to 3\",\"W1O\",\"newLine\",\"UNSIGNED_SHORT\",\"append\",\"osDetectionResults\",\"justify-content-center\",\"navigatorUa\",\"px-0\",\"uaEngine\",\"denied\",\"secUA\",\"col-md-6\",\"ml-7\",\"platform\",\"FINGERPRINT_MASKING\",\"open\",\"async\",\"pxlscn-geolocation\",\"ie-8-\",\"MAs\",\"testCanvas2d\",\"substring\",\"isNotBot\",\"card-columns\",\"webglFp\",\"Canvas hash\",\"renderer2\",\"createDynamicsCompressor\",\"Languages from Javascript\",\".pxlscn-img-status[_ngcontent-%COMP%]{height:4.6rem}\",\"Geolocation\",\"fillStyle\",\"col-lg-12\",\"information-icon\",\"72px\",\"enable\",\"altitude\",\"DoNotTrack\",\"root\",\"DEPTH_TEST\",\"devicePixelRatio\",\"additional-check-container\",\"hasOwnProperty\",\"MARKER_PSEUDO\",\"timezoneAndTime\",\"Firefox-30-0\",\"supportsColor\",\"length\",\"googleSpeechVoices\",\"fonts\",\"Check Geo API \",\"fillText\",\"Lbi\",\"plugins\",\"Internet Explorer-9-0,Edge-0-7\",\"textShadow\",\"comparedResult\",\"permissions\",\"_isEmpty\",\"javascript:void(0);\",\"Q6J\",\"isAnonymousProxy\",\"webglParams\",\"We've detected you're using a Chromium-based browser that's not \",\"mobile\",\"getComputedStyle\",\"Your IP looks good\",\"window\",\"jsModifyDetected\",\"ngUnsubscribe\",\"canvasNoiseOn2d\",\"canvasTest\",\"LFG\",\"blackBright\",\"Firefox-3.6-4\",\"btn\",\"missing channel labels property: \",\"Daylight savings time\",\"`chalk.constructor()` is deprecated. Use `new chalk.Instance()` instead.\",\"getCountryInfo\",\"8Iulmhg\",\"object\",\"abs\",\"isInteger\",\"span\",\"platformId\",\"changeDetectionRef\",\"hsl\",\"Your browser version is outdated\",\"textAlign\",\"unmaskedVendor\",\".verifiedMark[_ngcontent-%COMP%]{opacity:1;cursor:initial}.verified-icon[_ngcontent-%COMP%]{height:18px;width:18px}.service-verified-text[_ngcontent-%COMP%]{font-size:1rem;text-transform:uppercase}.service-title[_ngcontent-%COMP%]{font-size:1.5rem}\",\"location\",\" all fonts (\",\"isLatest\",\"Android\",\"updateIntegrationStatus\",\"The latest version of \",\"getBotStatus\",\"audioContextFp\",\"core\",\"BROWSER_INTEGRITY\",\"bufferData\",\"notFound\",\"details\",\"coreTestService\",\"shaderSource\",\"entries\",\"catch\",\"ALo\",\"safari-4\",\";2;\",\"mb-8\",\"OPERA_HIDE_CHROME_AD\",\"text-muted\",\" Latitude: \",\"FYo\",\"model\",\"handlePermission\",\"timeFromIPAddr\",\"isPublicProxy\",\"cssHacks\",\"channels\",\"d-flex\",\"/assets/mcil.png\",\"assets/icons/4-good.svg\",\"forEach\",\"value\",\"/assets/sttfpage.html#testzone:~:text=THIS%20IS%20TEST\",\"Not ok\",\"grey\",\"consistency-container\",\"names\",\"isChromiumBased\",\"acceptLanguage\",\"innerText\",\"remove\",\"Very likely you are using Proxy\",\"PDF Viewer\",\"isDST\",\"navigator\",\"uaBrowser\",\"pxlscn-fonts\",\"secMobile\",\"availScreenSize\",\"col-md-10\",\"checkOperaHideAd\",\"browserVersion\",\"Navigator\",\"buildID\",\"oxw\",\"mt-3\",\"qZA\",\"red-solid-box\",\"assets/icons/Warning-icon_result.svg\",\"drawImage\",\"coreTestType\",\"openAll\",\"Firefox\",\"createProgram\",\"/assets/pdf.pdf\",\"py-6\",\"mixedContentImageLoading\",\"C11\",\"class\",\"_uU\",\"F$t\",\"function\",\"hash\",\"bodyText\",\"isAnonymous\",\"555568UGYyLF\",\"C15\",\"addTestResult\",\"getBrowser\",\"checkJsModificationValue\",\"result\",\"trim\",\"IS_MOBILE\",\"text-success\",\" Speed: \",\"assign\",\"LOCATION_MASKING\",\"createEvent\",\"r16\",\"asObservable\",\"assets/icons/tile_icon_good.svg\",\"detectedResultsList\",\"fontSize\",\"py-5\",\"getOsStatus\",\"offcanvas\",\"locale\",\" Public IP: \",\"webRTCdata\",\"detectedResults\",\"CHM\",\"httpHeaders\",\"xyz\",\"closeAll\",\"ngClass\",\"What websites see about you\",\"Firefox-11-22\",\"bgBlackBright\",\"coreTestsService\",\" ISP: \",\"disconnect\",\"hsv\",\"checkMarkerPseudo\",\"ontouchstart\",\"VERTEX_SHADER\",\"[card-body]\",\"pxlscn-location-masking\",\"doNotTrack\",\"assets/icons/1-bad.svg\",\"guess\",\"utils\",\"textTransform\",\"distance\",\"OperaFrame\",\" Chrome-22-28,Safari-7-0,Mobile Safari-7-0,Edge-45-0,Firefox-17-0 \",\"attributes\",\"assets/icons/check_circle-24px.svg\",\"absolute\",\"changed\",\"isChrome\",\"\\u001b[49m\",\"synth\",\"test failed by fallback: \",\"Edge\",\"nodeValue\",\"758427tTWUTy\",\" Altitude: \",\"Chrome-29-0,Opera16-0\",\"setStyle\",\"bot-detection-container\",\"websites\",\"RGBA\",\"TRIANGLES\",\"Firefox-24-25\",\"getContext\",\"pxlscn-card-body-title\",\"frequency\",\"WebGL hash\",\".bot-detection-container[_ngcontent-%COMP%]   .bot-detection-context[_ngcontent-%COMP%]{height:100%}.bot-detection-container[_ngcontent-%COMP%]   .integration-text[_ngcontent-%COMP%]{padding:0 0 0 12px!important;margin:0!important}@media (min-width: 768px){.bot-detection-container[_ngcontent-%COMP%]{border-top:1px solid #414141}}@media (max-width: 767px){.bot-detection-container[_ngcontent-%COMP%]{border-top:none}}\",\"monospace\",\"isAnonymousVpn\",\"bgColor\",\"innerHTML\",\"IS_IOS\",\"firefox-27-28\",\"userAgentJS\",\"localIPv4\",\"javascript:eval(atob(\\\"c2V0VGltZW91dCgoKT0+e2NvbnN0IGZwYyA9IG5ldyB0b3AuRnBjKCk7ZnBjLmNvbGxlY3QoKS50aGVuKGU9PntwYXJlbnQucG9zdE1lc3NhZ2Uoe21lc3NhZ2VTb3VyY2U6ImZwQ29sbGVjdCIsdmFsdWU6ZS5nZXRGaW5nZXJwcmludCgpfSwiKiIpfSl9LDUwMCk7\\\"))\",\"⃐∫∑{amlρiюR>दे來'ਊ☣ث៌\uebcb\ue82fहै।က౪౫汉॥\",\"9304210YPVIkE\",\"ng-container\",\"textContent\",\"addTest\",\"createBuffer\",\"85 or below\",\"TgZ\",\"Internet Explorer-9-0,Edge-0-8\",\"lineHeight\",\"next\",\"BQk\",\"isTorExitNode\",\"GET\",\"Invalid Chalk template style argument: \",\"audioTimeout\",\"type\",\"sqrt\",\"text-decoration-underline\",\"hidden\",\"ISP\",\"Firefox-22-24\",\"px-8\",\"frameFpCollect\",\"Dn7\",\"mobile \",\"clear\",\"checkGeoApi\",\"text-center\",\"toggletext\",\"79 or below\",\"d-sm-inline-block\",\"additional-geo-check-btn\",\"filter\",\"flex-nowrap\",\"mb-7\",\"ie-9\",\"flex-row\",\"pxlscn-browser-integrity\",\"hardwareConcurrency\",\"edge-16\",\"Qsj\",\"channel and label counts mismatch: \",\"NAVIGATOR_SCHEDULING\",\"AsE\",\"card-body\",\"Platform\",\"changeMode\",\"d-md-inline-block\",\"addEventListener\",\"loadSpeechSynthesis\",\"text-muted geo-text\",\"setPrototypeOf\",\"loadCompleted\",\"userType\",\"getVoices\",\"AudioContext hash\",\"getChannelData\",\"voices\",\"ipZone\",\"scheduling\",\"body\",\"fontWeight\",\"stringify\",\"bitness\",\"checkFingerprintMasking\",\"min\",\"checkBrowserConsistency\",\"nativeWindow\",\"unmaskedRenderer\",\"isOpera\",\"hcg\",\"ngOnChanges\",\"ɵfac\",\"onmessage\",\" Longitude: \",\"checkOptionalChaining\",\"Chalk template literal is missing \",\"//www.google.\",\"style\",\"color\",\"availHeight\",\"message\",\"card\",\"country\",\"getConnectionInfo\",\"WEBRTC_LEAK\",\"pxlscn-fingerprint-masking\",\"YNc\",\"mt-lg-5\",\"oncomplete\",\"getNamedItem\",\"ie-10\",\"pxlscn-navigator\",\"parent\",\"level\",\"exports\",\"msMaxTouchPoints\",\"displayAdditionalCheck\",\"parser\",\"href\",\"visible\",\"checkWebworkerValues\",\"createElement\",\"textDecoration\",\"pop\",\"show less\",\"compileShader\",\"mb-md-4\",\"resolve\",\"userAgent\",\"prototype\",\"000000\",\"getOwnPropertyNames\",\"justify-content-start\",\"127.0.0.1\",\"operaFrame\",\"pxlscn-additional-check\",\"drawingBufferWidth\",\"col-12\",\"wrap\",\"showLoading\",\"assets/icons/2-bad.svg\",\"externalIPv4\",\"VKq\",\"matchMedia\",\"mt-4\",\"keys\",\"initialize\",\"checkCss\",\"location-icon\",\"ngOnDestroy\",\"call\",\"uaDevice\",\"red\",\"isCanvas\",\"sort\",\"values\",\"trunc\",\"timeJS\",\"assets/icons/4-bad.svg\",\"setValueAtTime\",\"slice\",\"map\",\"\\u001b[39m\",\"constructor\",\"format\",\"join\",\"timeDataFromJS\",\"stderr\",\"IP address\",\"ansi16\",\"Hide\",\"Hsn\",\"pxlscn-consistency-check\",\"showMore\",\"consistencyStatus\",\"ɵmod\",\"integrated$\",\"onload\",\"PROXY\",\"error\",\"webgl\",\"pxlscn-home\",\"fallback\",\"connect\",\"showStatus\",\"offsetWidth\",\"Unknown Chalk style: \",\"ngIf\",\"cos\",\"appendStr\",\"drawingBufferHeight\",\"speechSynthesis\",\"bgGray\",\"floor\",\"title\",\"pxlscn-card\",\"( any-hover: none )\",\"invisible\",\"attachShader\",\"Unknown\",\"has\",\"availableScreenSize\",\"assets/icons/information-button.svg\",\"loading\",\" browser is \",\"User-Agent (Javascript)\",\"replace\",\"toDataURL\",\".invisible[_ngcontent-%COMP%]{width:1px;height:1px}.pxlscn-img-status[_ngcontent-%COMP%]{height:4.6rem}\",\"setTimeout\",\"normal\",\"getValue\",\"pxlscn-hardware-fingerprints\",\"范準ஒ=3ث॔ଢ଼\uf71dมӸӘ◌̊‐\",\"firefox-22-24\",\"consistency-status-text\",\"apitService\",\"resolvedOptions\",\"contentDocument\",\"latestVersion\",\"dispatch\",\"webpackChunkfpt\",\"lastIndex\",\"lab\",\"checkWebRTCLeakVersion\",\"getDevice\",\"toUpperCase\",\"pl-7\",\"INVALID_UA\",\"OPTIONAL_CHAINING\",\"match\",\"reduce\",\"false::\",\"labels\",\"route\",\"consistency-section\",\"checkLocationMasking\",\"Browser\",\"intlLocale\",\"ie-7-\",\"embed\",\"Internet Explorer-9-0,Edge-10-0\",\"FLOAT\",\"You are using a Chromium-based browser\",\"inverse\",\"logged\",\"coords\",\"url\",\"checkNavigatorScheduling\",\"browserOfficialName\",\"all\",\"missing channels property: \",\"string\",\"managerService\",\"section\",\"detectedResults$\",\"col-md-12\",\"canvasFonts\",\" (`}`)\",\"version\",\"then\",\"architecture\",\"every\",\"timeZone\",\" You are not masking your fingerprint. \",\"_generator\",\" inconsistent \",\"navData\",\"attachEvent\",\"close\",\" Check Geo API was not allowed. \",\"getImageData\",\"ngIfElse\",\"Screen resolution\",\"align-items-start\",\"sin\",\"isIOS\",\"fromCharCode\",\"key\",\"firefox-30\",\"mt-md-4\",\"Location\",\"conversion\",\"ngForOf\",\"any\",\"ɵcmp\",\"uaHttp\",\"pl-2\",\"keyword\",\"secFullVersion\",\"template\",\".additional-check[_ngcontent-%COMP%]:before{border-width:0 48px 0 0;position:absolute;border-style:solid;border-color:transparent #00aac0 transparent;left:-40px;content:\\\"\\\";display:block;width:8px;height:48px;margin-top:-4px;border-radius:48px}.additional-check[_ngcontent-%COMP%]{overflow:hidden;position:relative;font-size:1.125rem}.additional-check[_ngcontent-%COMP%]   .title[_ngcontent-%COMP%]{color:#e8e8e8;line-height:40px}.additional-check[_ngcontent-%COMP%]   .summary[_ngcontent-%COMP%]{color:#7a7a7a;display:inline-block}.additional-check[_ngcontent-%COMP%]   .summary[_ngcontent-%COMP%]   .more-info-icon[_ngcontent-%COMP%]{cursor:pointer}\",\" + \",\"isShow\",\"availWidth\",\".css-os-detecion{width:1px;height:1px;overflow:hidden}.pxlscn-img-status{height:4.6rem}@media \\\\fffdscreen{.possiblilty{display:none}.safari-7{display:inline-block}}@media screen and (-webkit-min-device-pixel-ratio: 0){.possiblilty{display:none}.chrome-22-28{display:inline-block}}@media screen and (-webkit-min-device-pixel-ratio: 0) and (min-resolution: .001dpcm){.possiblilty{display:none}.chrome-29{display:inline-block}}@media screen and (-moz-images-in-menus: 0){.possiblilty{display:none}.firefox-3_6{display:inline-block}}@media screen and (min--moz-device-pixel-ratio: 0){.possiblilty{display:none}.firefox-4-8{display:inline-block}}@media (min--moz-device-pixel-ratio: 0) and (min-width: 0px){.possiblilty{display:none}.firefox-11-22{display:inline-block}}@supports (-moz-appearance: meterbar) and (display: flex){.possiblilty{display:none}.firefox-22-24{display:inline-block}}@supports (-moz-appearance: meterbar) and (cursor: zoom-in){.possiblilty{display:none}.firefox-24-25{display:inline-block}}@supports (-moz-appearance: meterbar) and (background-attachment: local){.possiblilty{display:none}.firefox-25-26{display:inline-block}}@supports (-moz-appearance: meterbar) and (image-orientation: 90deg){.possiblilty{display:none}.firefox-26-27{display:inline-block}}@supports (-moz-appearance: meterbar) and (all: initial){.possiblilty{display:none}.firefox-27-28{display:inline-block}}@supports (-moz-appearance: meterbar) and (list-style-type: japanese-formal){.possiblilty{display:none}.firefox-28-29{display:inline-block}}@supports (-moz-appearance: meterbar) and (background-blend-mode: difference,normal){.possiblilty{display:none}.firefox-30{display:inline-block}}@media screen and (min-width: 0\\\\fffd){.possiblilty{display:none}.safari-4{display:inline-block}}@media \\\\fffdscreen{.possiblilty{display:none}.ie-8-{display:inline-block}}@media screen\\\\\\t{.possiblilty{display:none}.ie-7-{display:inline-block}}@media screen and (min-width: 0\\\\fffd){.possiblilty{display:none}.ie-9{display:inline-block}}@media screen and (-ms-high-contrast: active),(-ms-high-contrast: none){.possiblilty{display:none}.ie-10{display:inline-block}}@media all and (-webkit-min-device-pixel-ratio: 10000),not all and (-webkit-min-device-pixel-ratio: 0){.possiblilty{display:none}.opera-11-{display:inline-block}}_:-o-prefocus .possiblilty,body:last-child .selector .possiblilty{display:none}_:-o-prefocus .opera-9_5,body:last-child .selector .opera-9_5{display:inline-block}@media (min-resolution: .001dpcm){_:-o-prefocus .possiblilty,.selector .possiblilty{display:none}_:-o-prefocus .opera-12,.selector .opera-12{display:inline-block}}@media all and (-webkit-min-device-pixel-ratio: 0) and (min-resolution: .001dpcm){.selector .possiblilty{display:none}.selector .opera-16{display:inline-block}}@supports (-ms-ime-align: auto){.possiblilty{display:none}.edge-16{display:inline-block}}\\n\",\"bindBuffer\",\"mb-lg-0\",\"isMobileDevice\",\" Accuracy: \",\"select\",\"concat\",\"toString\",\"d-inline-block\",\"threshold\",\"Firefox-4-8\",\"279Mzthlh\",\"extra\",\"PDF_PLUGIN\",\"hostname\",\"37272pPEYtL\",\"text\",\"iframe\",\"opera-16\",\"forChild\",\"Firefox-27-28\",\"OfflineAudioContext\",\"assets/icons/tile-icon-bad.svg\",\"isEdge\",\"publicIp\",\"codes\",\"protocol\",\"data\",\"Time and language\",\"isOsIos\",\"accuracy\",\"parseFloat\",\"setAttribute\",\"screen\",\"pow\",\"offset-md-1\",\"languageHttp\",\"IP location\",\"warn\",\"get\",\"additional-check-box mt-6 col-12 col-md-6\",\"ngOnInit\",\"browserName\",\"createShader\",\"d-block\",\"float-right\",\"lanJS\",\"isMobile\",\"additionalChecks$\",\"appendChild\",\"assets/icons/3-good.svg\",\" Internet Explorer-9-0,Edge-9-0,Safari-4-0,Mobile Safari-4-0,Android-2.3-0 \",\"uaFullVersion\",\"raw\",\"userAgentData\",\"size\",\"isExtensionProxy\",\"now\",\"push\",\"\\\";v=\\\"\",\"Opera-0-11\",\"width\",\"xp6\",\"bgGrey\",\"oscpu\",\"verified-icon\",\"setProperty\",\"subtle\",\"pxlscn-bot-detection\",\"performance\",\"readPixels\",\"pxlscn-card-body-text\",\"consistency\",\"col-lg-3\",\"WindowObject\",\"fallbackTimeout\",\"removeChild\",\"BrowserList\",\" Detected location - \",\"interval\",\"assets/icons/2-good.svg\",\"getAttribLocation\",\"const fallbackValue = {\\n          messageSource: 'fpWebworker',\\n          value: {\\n            navigatorUa: self.navigator.userAgent,\\n            offcanvas: null\\n          }\\n        };\\n        try{\\n          if(!'OffscreenCanvas' in globalThis){\\n            postMessage(fallbackValue);\\n          } else{\\n        const canvas = new OffscreenCanvas(16, 20);\\n      const gl =\\n        canvas.getContext('webgl') || canvas.getContext('experimental-webgl');\\n      const extensionDebugRendererInfo = gl.getExtension(\\n        'WEBGL_debug_renderer_info'\\n      );\\n      postMessage({\\n        messageSource: 'fpWebworker',\\n        value: {\\n          navigatorUa: self.navigator.userAgent,\\n          offcanvas: {\\n            unmasked_vender: gl.getParameter(\\n              extensionDebugRendererInfo.UNMASKED_VENDOR_WEBGL\\n            ),\\n            unmasked_renderer: gl.getParameter(\\n              extensionDebugRendererInfo.UNMASKED_RENDERER_WEBGL\\n            )\\n          }\\n        }\\n      });}}\\n      catch{\\n        postMessage(fallbackValue);\\n      }\",\"run\",\"ng-template\",\"indent\",\"mr-6\",\"getElementById\",\"yellow\",\"_UZ\",\"Y36\",\"SCROLL_TO_TEXT_FRAGMENT\",\"fontHash\",\"NumberFormat\",\"WebGL unmasked vendor\",\"MICROSOFT_SPEECH_VOICES\",\"mb-lg-8\",\"getAudioContext\",\"assets/icons/1-good.svg\",\"daylightJS\",\".consistency-container[_ngcontent-%COMP%]{font-size:1.25rem;padding-right:15px;padding-left:15px;margin-right:auto;margin-left:auto}@media (min-width: 768px) and (max-width: 992px){.consistency-container[_ngcontent-%COMP%]   .consistency-section[_ngcontent-%COMP%]:nth-child(odd){border-right:1px solid #414141}}@media (min-width: 992px){.consistency-container[_ngcontent-%COMP%]   .consistency-section[_ngcontent-%COMP%]:not(:nth-child(4)){border-right:1px solid #414141}}.additional-check-container[_ngcontent-%COMP%]{font-size:1.25rem;padding:0}.additional-check-container[_ngcontent-%COMP%]   .additional-check-box[_ngcontent-%COMP%]{flex:1 0 50%;padding:0}.additional-check-container[_ngcontent-%COMP%]   .additional-check-box[_ngcontent-%COMP%]:nth-child(odd)   .additional-check-container[_ngcontent-%COMP%]   .additional-check-box[_ngcontent-%COMP%]:not(.additional-check-single-node){padding-right:.75rem}.additional-check-container[_ngcontent-%COMP%]   .additional-check-box[_ngcontent-%COMP%]:nth-child(even){padding-left:.75rem}.consistency-status-text[_ngcontent-%COMP%]{display:inline-block;padding-left:.5rem}.consistency-status-icon[_ngcontent-%COMP%]{width:45px;height:45px}\",\"checkFakeNavigatorObject\",\"NdJ\",\"fromCodePoint\",\"Chrome\",\"none\",\"currentTime\",\"alt\",\"verifiedMark\",\"notOk\",\"test\",\"display\",\";5;\",\"isArray\",\"store\",\"sBO\",\"row\",\"position\",\"ngAfterViewInit\",\"additional-check\",\"indexOf\",\"bg-dark\",\"secPlatform\",\"mb-0\",\"Hardware fingerprints\",\"null\",\"Microsoft Edge\",\"btn-link\",\"ngFor\",\"detectChanges\",\"secModel\",\"latitude\",\"triangle\",\".pxlscn-card[_ngcontent-%COMP%]{font-size:1.125rem}.pxlscn-card[_ngcontent-%COMP%]   .card-header[_ngcontent-%COMP%]{display:inline-block;width:100%;color:#7a7a7a;background-color:#2c2c2c;font-size:1.5rem!important}\",\"connectionInfo\",\"getElementsByTagName\",\"Google Chrome\",\"destination\",\"service-verified-text\",\"release\",\"defineProperty\",\"cJS\",\"pxlscn-what-websites-see\",\"visibility\",\"toLowerCase\",\"\\n      additional-check-container\\n      col-12\\n      mt-4\\n      py-2\\n      flex-row\\n      d-flex\\n      flex-wrap\\n      justify-content-start\\n    \",\"pin\",\"loader\",\"onvoiceschanged\",\"Show\",\"host\",\"isHostingProvider\",\"proxy\",\"renderedBuffer\",\"connectionInfoInsight\",\"FRAGMENT_SHADER\",\"isOsAndroid\",\"scrollTo\",\"TouchEvent\",\"Instance\",\"pipe\",\"buffer\",\"onchange\",\"Free IP info check \",\"jsFontsKey\",\"apple\",\"C10\",\"EpF\",\"getEngine\",\"platformVersion\",\"pxlscn-card-divider\",\"STATIC_DRAW\",\"getOS\",\"canvas\",\"coordinates\",\"$implicit\",\"detectionTimeout\",\"Ios\",\"ansi256\",\"messageSource\",\"exec\",\"ml-8\",\"src\",\"substr\",\"height\",\"secArch\",\"IS_ANDROID\",\"about:blank\",\"BOT_DETECTION\",\" Automation framework detected \",\"bot-detection-context\",\"opera-11-\",\"availableFonts\",\"round\",\" consistent \",\"safari-7\",\"whiteSpace\",\"status\",\"card-header\",\"brands\",\"item\",\"engineVersion\",\"geolocation\",\"summary\",\"additional-check-box\",\"getPropertyValue\",\"lch\",\"b16\",\"internalid\",\"MIXED_CONTENT_IMAGE_LOADING\",\"pxlscn-proxy\",\"iframeCheckings\",\"getBrowserStatus\",\" Your browser fingerprints are \",\"max\",\"checkScrollToTextFragment\",\"atan2\",\"additionalCheckItem\",\"ARRAY_BUFFER\",\"img-fluid\",\"localhost\",\"fontFamily\",\"Good\",\"attribute vec3 coordinates;void main(void) { gl_Position = vec4(coordinates, 1.0);}\",\"longitude\",\"mb-md-0\",\" Very likely you are masking your fingerprint. \",\"clearAdditionalCheck\",\"nmd\",\"consistency-status-icon\",\"version \",\"displayBlockedText\",\"selfFpCollect\",\"cmyk\",\"serif\",\"pxlscn-loader\",\"pxlscn-img-status\",\"click\",\"uaOS\",\"search\",\"_styler\",\"fontsUpdated\",\"microsoftSpeechVoices\",\"complete\",\"Internationalization API\",\"Font hash\",\"unshift\",\"Opera-9.5-12\",\"ELEMENT_ARRAY_BUFFER\",\"STTFPAGE\",\"lcZ\",\"align-middle\",\"Chrome PDF Plugin\",\"clearColor\",\"maxTouchPoints\",\"splice\",\"CANVAS_NOISE\",\"button\",\"state\",\"checkAdditionalCheck\",\"Fonts\",\"px-7\",\"drawRectangle\",\"toggle\",\"m-auto\",\"osFontsStatus\",\"989490YwHSsw\",\"detectedResultsSubj\",\"canvasFp\",\"Xpm\",\"secBitness\",\"chrome-22-28\",\"split\",\"::marker\",\"Opera\",\"C12\",\"isAndroid\",\"attack\",\"offsetHeight\",\"div\",\"notIntegrated\",\"font\",\"pxlscn-connections\",\"number\",\"geo-text\",\"hij\",\"logRequest\",\"py-2\",\"COLOR_BUFFER_BIT\",\"longBody\",\"mt-6\",\"pdfPluginFrame\",\"mmmmmmmmmmlli\",\"oAB\",\"languagesJS\",\"ɵinj\",\"createObjectURL\",\"pxlscn-time-language\",\"GOOGLE_SPEECH_VOICES\",\"assets/icons/verified.svg\",\"getHttpHeaderUserAgent\",\"firefox-4-8\",\"hasResult\",\" ... \",\"101129AoCtIH\",\"0px\",\"auto\",\"30OzlbvU\",\"d-none\",\"hex\",\"Bad\",\"py-8\",\"checkIdenticalSecCh\",\"scrResolution\",\"Microsoft Edge PDF Plugin\",\"ynx\",\"a Сhromium-based browser\",\"hashes\",\"ansi16m\",\"87 or below\",\"srgb\",\"opera-9_5\",\"bf9da7959d914298f9ce9e41a480fd66f76fac5c6f5e0a9b5a99b18cfc6fd997\",\"isAdditional\",\"secPlatformVersion\",\"name\",\"sameGroup\",\"rgb\",\"unmasked_renderer\",\"iLocale\",\"rendererFactory2\",\"load\",\"end\",\"ansi\",\"updateListOfSpeechVoices\",\"assets/icons/3-bad.svg\",\"set\",\"img\",\"mimeTypes\",\"lanHttp\",\" => \",\"apiService\",\"WebRTC address\",\"uaBrowserEngine\",\"rec2020\",\"gray\",\"document\"]");


function getString(index) {
  index -= 259;
  return srcArray[index];
}

const code = fs.readFileSync('original.js', { encoding: 'utf-8' });

const ast = parse(code);

const varNames = [
  '_0x1ce6d6',
  '_0x1cd5bb',
  '_0x143d9e',
  '_0x517d25',
  '_0x29b044',
  '_0x329018',
  '_0x37864a',
  '_0x7f97df',
  '_0x3b8bc7',
  '_0x2ee877',
  '_0x59bb5c',
  '_0x283937',
  '_0x2b2e0d',
  '_0x221b56',
  '_0x4749ea',
  '_0x1cf4dc',
  '_0x45a06e',
  '_0x5730aa',
  '_0x4e8a99',
  '_0x3563e7',
  '_0xc41ac0',
  '_0x181e70',
  '_0x5ed863',
  '_0x1297fc',
  '_0x49665e',
  '_0x1c8cbf',
  '_0x2aa785',
  '_0x3de2d0',
  '_0x16c286',
  '_0x14935f',
  '_0x527c2e',
  '_0x2d5f48',
  '_0x457a96',
  '_0xe8e523',
  '_0x412ba3',
  '_0x1a0a52',
  '_0xf73953',
  '_0x398a2f',
  '_0x7f200b',
  '_0x4ee2fd',
  '_0x30e5fc',
  '_0x5d059a',
  '_0x21ca74',
  '_0x2e65ed',
  '_0x333e16',
  '_0x46d974',
  '_0x5d4831',
  '_0x443b4a',
  '_0x346cf4',
  '_0x3a3535',
  '_0x5a82ca',
  '_0x396115',
  '_0x35f223',
  '_0x34b3f3',
  '_0x32813b',
  '_0xc943b8',
  '_0x3aa31d',
  '_0x5270dc',
  '_0x434826',
  '_0x34dbfe',
  '_0x39cfa1',
  '_0x407dae',
  '_0x3244aa',
  '_0x43f8d7',
  '_0x543cd2',
  '_0x38a37f',
  '_0x8afc0',
  '_0x21e223',
  '_0x4c9e2a',
  '_0x3c492b',
  '_0x38ec51',
  '_0xec3748',
  '_0x4a731c',
  '_0x13b6c7',
  '_0x3fbb81',
  '_0x50b356',
  '_0xbf0e8b',
  '_0x39d1e3',
  '_0x1cbd8e',
  '_0x7a44b8',
  '_0x3cf551',
  '_0x472ce0',
  '_0x434d40',
  '_0x2b5f59',
  '_0x46e63c',
  '_0xca92b9',
  '_0xfd265',
  '_0x57be26',
  '_0x52630a',
  '_0x47b5af',
  '_0x5f07e0',
  '_0x20f8de',
  '_0x417199',
  '_0xc96f31',
  '_0x32b284',
  '_0x1ae8fc',
  '_0x29643e',
  '_0x504831',
  '_0x1ce1ea',
  '_0x1ae417',
  '_0x4b4188',
  '_0x375169',
  '_0x486200',
  '_0x507bcd',
  '_0x4f13d3',
  '_0x4eedda',
  '_0x333016',
  '_0x5edbbb',
  '_0x3132ba',
  '_0xc435cc',
  '_0x38fc7d',
  '_0x2cf914',
  '_0x2a9e7b',
  '_0xf3161f',
  '_0x22887c',
  '_0x45777f',
  '_0x20d54d',
  '_0x1a7eb8',
  '_0x7de88c',
  '_0x41f2c2',
  '_0x5efb2d',
  '_0x2967b2',
  '_0x4bc6bf',
  '_0x4785b5',
  '_0x416c93',
  '_0x37a82f',
  '_0x3a77f8',
  '_0x142c0e',
  '_0x5e33b8',
  '_0x689813',
  '_0x560564',
  '_0x3248cf',
  '_0x1d5009',
  '_0x198a20',
  '_0x4fa4ef',
  '_0x40a216',
  '_0xf9180c',
  '_0x184b51',
  '_0x37df90',
  '_0x2c0be2',
  '_0x553f84',
  '_0x1b7ff9',
  '_0x2d481',
  '_0x216b7b',
  '_0x34f57',
  '_0x420e97',
  '_0x50da9e',
  '_0x197291',
  '_0x148939',
  '_0x28bd3a',
  '_0xeb0b37',
  '_0x1579f8',
  '_0x28b761',
  '_0x237e6f',
  '_0x481bc8',
  '_0x1d9eba',
  '_0x9e33cd',
  '_0x2376bb',
  '_0x1108dd',
  '_0x4d830e',
  '_0x33ad78',
  '_0x452d77',
  '_0x18cce7',
  '_0x2cd0e4',
  '_0x12720f',
  '_0x39f877',
  '_0x4c092d',
  '_0x467430',
  '_0x46f93d',
  '_0x2ba247',
  '_0x20a70c',
  '_0x412890',
  '_0x6c0e6f',
  '_0x2d9c30',
  '_0x13aa57',
  '_0x536a69',
  '_0x253bd8',
  '_0x3f1da8',
  '_0x3850df',
  '_0x2b269a',
  '_0x5930a9',
  '_0x5d0752',
  '_0x474715',
  '_0x1eeeb1',
  '_0x14a545',
  '_0x1a11f8',
  '_0x5b0d08',
  '_0x223368',
  '_0x158d2f',
  '_0x2ca385',
  '_0x394dbd',
  '_0x2c7c62',
  '_0x4e90c2',
  '_0x3f36f3',
  '_0x33d513',
  '_0x3cfe8b',
  '_0x5e78da',
  '_0x1900e3',
  '_0x4695f7',
  '_0x41bb15',
  '_0x5de1f5',
  '_0x413ca1',
  '_0x459e94',
  '_0x3cdad5',
  '_0x46a7bf',
  '_0x1d1c81',
  '_0x19bed8',
  '_0x317783',
  '_0x20647b',
  '_0x156aa0',
  '_0x57219f',
  '_0x4a425d',
  '_0x4f6773',
  '_0x146c41',
  '_0x5cf6c7',
  '_0x2e66a3',
  '_0x3c0074',
  '_0x269c0b',
  '_0x3852f8',
  '_0x3c84be',
  '_0x1784db',
  '_0x44ea07',
  '_0x2b839a',
  '_0x3099c9',
  '_0x311c3e',
  '_0x355b7f',
  '_0x5bae52',
  '_0x2f42e0',
  '_0xe79f12',
  '_0x141af3',
  '_0x3d78d0',
  '_0x63ea87',
  '_0x1e4eec',
  '_0x5b8457',
  '_0x310c13',
  '_0x53524b',
  '_0x3ccb2c',
  '_0x480095',
  '_0x1bfd12',
  '_0x15543e',
  '_0x237c5c',
  '_0x49ca6b',
  '_0x5df1b3',
  '_0x4d2c70',
  '_0x5b3030',
  '_0x10442f',
  '_0x229402',
  '_0x256104',
  '_0x35644f',
  '_0x108e64',
  '_0x56c277',
  '_0x12f104',
  '_0x21e382',
  '_0x233d7e',
  '_0x43b821',
  '_0x4483b1',
  '_0x313cfd',
  '_0x10c39e',
  '_0x3238a2',
  '_0x10dafd',
  '_0x380f26',
  '_0x185c20',
  '_0x6d3396',
  '_0x4dfc48',
  '_0x2268bf',
  '_0x5df89e',
  '_0x59e5db',
  '_0x272fad',
  '_0x54bbfe',
  '_0x1d481f',
  '_0x1af65e',
  '_0x20a5d6',
  '_0x2b0468',
  '_0x2d65b9',
  '_0x26b26b',
  '_0x2c1e25',
  '_0xc62e99',
  '_0x38c8ec',
  '_0x45deb9',
  '_0x3c16af',
  '_0x27b969',
  '_0x1f843c',
  '_0x5f52d7',
  '_0x476597',
  '_0x577bf9',
  '_0xe222f0',
  '_0x29101c',
  '_0x47b675',
  '_0x157f69',
  '_0x20b635',
  '_0x5a8f7e',
  '_0xe850d3',
  '_0x527951',
  '_0xa433ed',
  '_0x5cd905',
  '_0x333eb2',
  '_0x207f5f',
  '_0x4fe361',
  '_0x55be7f',
  '_0x208353',
  '_0xdf6c88',
  '_0x38eedc',
  '_0x1701e6',
  '_0x96a868',
  '_0x331a76',
  '_0xd2a2c4',
  '_0x150c85',
  '_0x571e3',
  '_0x24a3c0',
  '_0x43631f',
  '_0x3d7d06',
  '_0x3e499f',
  '_0x428583',
  '_0x18e148',
  '_0x44ff24',
  '_0x5a823a',
  '_0x569431',
  '_0x2c394c',
  '_0x48502f',
  '_0x308a61',
  '_0x18cfef',
  '_0x189230',
  '_0x4262a9',
  '_0xf84fa',
  '_0x4440ba',
  '_0x260af8',
  '_0x4ad4d8',
  '_0xe38ad2',
  '_0x62c4a6',
  '_0xb0e61b',
  '_0x48eaec',
  '_0x184562',
  '_0x3d8c05',
  '_0x3ae9b9',
  '_0x2bb2b8',
  '_0x5b243e',
  '_0x3c6648',
  '_0x23131f',
  '_0x11ca44',
  '_0x3598ff',
  '_0x2208b0',
  '_0x1d802e',
  '_0x580fcf',
  '_0x462a6b',
  '_0xbec7ae',
  '_0x29fd02',
  '_0x4c6cd8',
  '_0x12566d',
  '_0xbfef42',
  '_0x30e7db',
  '_0x54ed6a',
  '_0x3a6cfe',
  '_0x2f5b7a',
  '_0x167a45'
];

// traverse.default(ast, {
//   VariableDeclarator: path => {
//     if (path.node.init && varNames.includes(path.node.init.name)) {
//       varNames.push(path.node.id.name)
//     }
//   }
// })

traverse.default(ast, {
  CallExpression: path => {
    if (varNames.includes(path.node.callee.name) && (path.node.arguments.length === 1) && path.node.arguments[0].type === 'NumericLiteral') {
      const index = path.node.arguments[0].value;
      const str = getString(index);
      path.replaceWith(t.stringLiteral(str))
    }
  }
});

let newCode = generate.default(ast, {}, code).code;

newCode = UglifyJS.minify(newCode, {
  mangle: false, 
  output: {
    beautify: true
  },
  compress: {
    sequences: true
  }

}).code;

fs.writeFile('deobfuscated.js', newCode, () => console.log('done!'))