import { parse } from "@babel/parser";
import traverse from "@babel/traverse";
import generate from "@babel/generator";
import * as t from "@babel/types";
import fs from "fs";

const code = fs.readFileSync('obfuscatorIO.js', {encoding : 'utf-8' });

const ast = parse(code);

let additionalCode = `
const srcArray = ['log', 'Requesting data from the server...', 'ZennoLab', 'Автоматизируй любые задачи в интернете', 'support@zennolab.com', 'Data recieved: ', 'stringify'];

function getString(index) {
  return srcArray[index];
}
`;
let funcsCode = '';
const fNames = [];

traverse.default(ast, {
  FunctionDeclaration: ({ node }) => {
    //funcsCode = funcsCode + generate.default(path.node).code + '\n';
    if (node.body.body[0] && node.body.body[0].type === 'ReturnStatement' && node.body.body[0].argument.callee.name === 'getString') {
      funcsCode = funcsCode + generate.default(node).code + '\n';
      fNames.push(node.id.name)
    }
  }
})

additionalCode += funcsCode;

traverse.default(ast, {
  CallExpression: (path) => {
    if (fNames.includes(path.node.callee.name)) {
      const callExpr = generate.default(path.node).code;
      //console.log(callExpr);
      const exprToEval = additionalCode + `\n  ${callExpr} `;
      path.replaceWith(t.stringLiteral(eval(exprToEval)));
    }
  } 
});

const newCode = generate.default(ast).code;
console.log(newCode);

//console.log(additionalCode)